/*  Development server for testing relative links and filepaths: */
var express = require('express')
var fs = require('fs')

var app = express()
app.use('/', express.static(__dirname + '/../../../'))

app.get('/:page', function(req, res, next){
	var path = __dirname + '/../../../' + req.params.page + '.html'
	fs.readFile(path, 'utf8', function (err,data) {
		if (err) {
			res.json({
				confirmation: 'fail',
				message: err.message
			})
			return
		}

		res.send(data)
	})
})


app.get('/:folder/:page', function(req, res, next){
	if (req.params.folder == 'vectors'){
		next()
		return
	}
	

	var path = __dirname + '/../../../'+req.params.folder+'/'+req.params.page+'.html'
	fs.readFile(path, 'utf8', function (err,data) {
		if (err) {
			res.json({
				confirmation: 'fail',
				message: err.message
			})
			return
		}

		res.send(data)
	})
})

app.get('/:folder/:folder2/:page', function(req, res, next){
	var path = __dirname + '/../../../'+req.params.folder+'/'+req.params.folder2+'/'+req.params.page+'.html'
	fs.readFile(path, 'utf8', function (err,data) {
		if (err) {
			res.json({
				confirmation: 'fail',
				message: err.message
			})
			return
		}

		res.send(data)
	})
})

// GET Handler
app.get('/vectors/:name', function(req, res, next){
	var path = __dirname + '/../../../vectors/js/index.js'
	fs.readFile(path, 'utf8', function(err, data) {
		if (err) {
			res.json({
				confirmation: 'fail',
				message: 'No vectors registered.'
			})

			return
		}

		var functions = require('../../../vectors/js')

		var func = functions[req.params.name]
		if (func == null){
			res.json({
				confirmation: 'fail',
				message: 'Vector ' + req.params.name + ' undefined'
			})

			return
		}

		func(req, res)
	})
})

// POST Handler
app.post('/vectors/:name', function(req, res, next){
	var path = __dirname + '/../../../vectors/js/index.js'
	fs.readFile(path, 'utf8', function (err,data) {
		if (err) {
			res.json({
				confirmation: 'fail',
				message: 'No vectors registered.'
			})

			return
		}

		var functions = require('../../../vectors/js')

		var func = functions[req.params.name]
		if (func == null){
			res.json({
				confirmation: 'fail',
				message: 'Vector ' + req.params.name + ' undefined'
			})

			return
		}

		func(req, res)
	})
})

app.listen(3000, function(){ 
	console.log('\nTurbo dev server running on http://localhost:3000')
	console.log('Open this address in a browswer to view your project.')
	console.log('This is a local environment for testing and is NOT actually live on the internet.')
	console.log('To turn off server: CONTROL-C')
})

